package com.pon3gaming.pegasusfly;

import org.bukkit.Material;
import org.bukkit.entity.HumanEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockDamageEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityShootBowEvent;
import org.bukkit.event.player.PlayerQuitEvent;

public class PegasusFlyListener implements Listener {

	@EventHandler(ignoreCancelled = true)
	public void onShoot(EntityShootBowEvent event) {
		if (event.getEntity() instanceof Player) {
			Player player = (Player) event.getEntity();
			if (PegasusFly.isPegged.contains(player.getName())
					&& player.isFlying()) {
				event.setCancelled(true);
			}
		}
	}

	@EventHandler(ignoreCancelled = true)
	public void onPegBuild(BlockPlaceEvent event) {
		if (PegasusFly.isPegged.contains(event.getPlayer().getName())
				&& event.getBlock().getType() != Material.SNOW_BLOCK
				&& event.getPlayer().isFlying()) {
			event.setCancelled(true);
		}
	}

	@EventHandler(ignoreCancelled = true)
	public void onInteract(BlockDamageEvent event) {
		if (PegasusFly.isPegged.contains(event.getPlayer().getName())
				&& event.getBlock().getType() != Material.SNOW_BLOCK
				&& event.getPlayer().isFlying()) {
			event.setCancelled(true);
		}
	}

	@EventHandler(ignoreCancelled = true)
	public void onAttack(EntityDamageByEntityEvent event) {
		if (event.getDamager() instanceof Player
				&& !(event.getEntity() instanceof Player)
				&& ((Player) event.getDamager()).isFlying()
				&& PegasusFly.isPegged.contains(((HumanEntity) event
						.getDamager()).getName())) {
			event.setCancelled(true);
		}
	}

	@EventHandler(ignoreCancelled = true)
	public void onLogout(PlayerQuitEvent event) {
		String playerName = event.getPlayer().getName();
		if (event.getPlayer().hasPermission("pegfly.fly")) {
			if (PegasusFly.isPegged.contains(playerName)) {
				PegasusFly.isPegged.remove(playerName);
			}
		}
	}
}